//+------------------------------------------------------------------+
//|                                                      Awesome.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2005, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 6
#property  indicator_color1  Green
#property  indicator_color2  Green
#property  indicator_color3  Yellow
#property  indicator_color4  Red
#property  indicator_color5  Green
#property  indicator_color6  Black

#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  2
#property indicator_width6  1

//
//
//
extern int    Ao1Price   =  PRICE_CLOSE;
extern int    Ao1Fast    =  5;
extern int    Ao1Slow    =  34;

extern int    Ac1Price   =  PRICE_MEDIAN;
extern int    Ac1Fast    =  5;
extern int    Ac1Slow     =  34;


//---- indicator buffers
double ao1up[];
double ao1dn[];
double ao1ln[];
double ac1up[];
double ac1dn[];
double ac1ln[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   SetIndexBuffer(0,ao1up); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,ao1dn); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,ac1up); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,ac1dn); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,ao1ln);
   SetIndexBuffer(5,ac1ln);
   
   return(0);

}
int deinit() { return(0); }


//+------------------------------------------------------------------+
//| Awesome Oscillator                                               |
//+------------------------------------------------------------------+
int start()
  {
   int    limit;
   int    counted_bars=IndicatorCounted();
   double prev,current;
   double prev1,current1;
   
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- macd
   for(int i=0; i<limit; i++)
   {
    
      ao1ln[i] = iMA(NULL,0,Ao1Fast,0,MODE_SMA,Ao1Price,i)-iMA(NULL,0,Ao1Slow,0,MODE_SMA,Ao1Price,i);
      ac1ln[i] = iMA(NULL,0,Ac1Fast,0,MODE_SMA,Ac1Price,i)-iMA(NULL,0,Ac1Slow,0,MODE_SMA,Ac1Price,i);
      ao1up[i] = EMPTY_VALUE;
      ao1dn[i] = EMPTY_VALUE;
      ac1up[i] = EMPTY_VALUE;
      ac1dn[i] = EMPTY_VALUE;
      if (ao1ln[i]>0) ao1up[i] = ao1ln[i];
      if (ao1ln[i]<0) ao1dn[i] = ao1ln[i];
      if (ac1ln[i]>0) ac1up[i] = ac1ln[i];
      if (ac1ln[i]<0) ac1dn[i] = ac1ln[i];
   }   
//---- dispatch values between 2 buffers
   bool up=true;
   for(i=limit-1; i>=0; i--)
      {
      current1=ac1up[i]-ac1dn[i];
      prev1=ac1up[i+1]-ac1dn[i+1];
      current=ao1ln[i];
      prev=ao1ln[i+1];
      
      if(current>prev) up=true;
      if(current<prev) up=false;
      if(current1>prev1) up=true;
      if(current1<prev1) up=false;
      if(!up)
        {
         ao1ln[i]=current;
         ao1ln[i]=0.0;
         ac1ln[i]=current1;
         ac1ln[i]=0.0;
        }
      else
        {
         ao1ln[i]=current;
         ac1ln[i]=0.0;
         
        }
     }
//---- done
   return(0);
  }
  
//+------------------------------------------------------------------+

